function settime(startTime, endTime) {
    turnEnd = endTime;
    var audio = document.getElementById("audio");
    audio.currentTime = startTime;
    audio.play();
}


function playme() {
    var SecondNexSibling = event.target.nextElementSibling.nextElementSibling;
    // SecondNexSibling ->  <u> tag (text) in which the attribute data-start is stored
    var myStartTime = SecondNexSibling.getAttribute("data-start");
    var myEndTime = SecondNexSibling.getAttribute("data-end");
    settime(myStartTime, myEndTime);
}


// toggle dropdown
/* When the user clicks on the button, toggle between hiding and showing the dropdown content */
function showdropdown() {
    document.getElementById("myDropdown").classList.toggle("show");
}

var yellow = 'rgb(255, 255, 0)';
var gold = 'rgb(255, 215, 0)';
var salmon = 'rgb(250, 128, 114)';
var aquamarine = 'rgb(127, 255, 212)';
var turquoise = 'rgb(64, 224, 208)';
var violet = 'rgb(238, 130, 238)';
var plum = 'rgb(221, 160, 221)';
var LightSlateGray = 'rgb(119, 136, 153)';

var annoDict = {
    "non-standard": yellow,
    "hesitation": gold,
    "elongation": salmon,
    "nichtbcms": aquamarine,
    "non-word": turquoise,
    "truncation": violet,
    "stutter": plum,
    "unclear": LightSlateGray
};


function showAllAnnotations(e) {
    if (!e.target.classList.contains("checked")) {
        // if checked
        for (var key in annoDict) {
            $('.' + key).each(function() {
                var range = document.createRange();
                range.selectNodeContents(this);

                const firstNodeSpan = range.startContainer;
                const lastNodeSpan = range.endContainer;

                const span = document.createElement("span");
                span.classList.add("highlighted");
                span.style.backgroundColor = annoDict[key];

                if (firstNodeSpan.closest("span.highlighted") && lastNodeSpan.closest("span.highlighted")) {
                    const highlightSpan = this.closest("span.highlighted");

                    highlightSpan.classList = [];
                    highlightSpan.classList.add("highlighted");
                    highlightSpan.classList.add("highlighted-" + key);
                    highlightSpan.style.backgroundColor = annoDict[key];
                } else {
                    // if span doesn't exist
                    if (firstNodeSpan.nodeName === "SPAN" && lastNodeSpan.nodeName === "SPAN") {
                        const range = new Range();
                        range.setStartBefore(firstNodeSpan);
                        range.setEndAfter(lastNodeSpan);
                        // finally surround with span.user-highlighted.user-highlighted-{input}
                        span.classList.add("highlighted-" + key);
                        range.surroundContents(span);
                    }
                }
            });
        }
        e.target.classList.add("checked");
    } else {
        // if unchecked
        for (var key in annoDict) {
            $('.' + key).each(function() {
                var range = document.createRange();
                range.selectNodeContents(this);

                const firstNodeSpan = range.startContainer;
                const lastNodeSpan = range.endContainer;
                if (firstNodeSpan.closest("span.highlighted") && lastNodeSpan.closest("span.highlighted")) {
                    if (this.closest("span.highlighted").classList.length === 2 &&
                        this.closest("span.highlighted").classList.contains("highlighted") &&
                        this.closest("span.highlighted").classList.contains("highlighted-" + key)) {
                        this.closest("span.highlighted").classList.remove("highlighted-" + key);
                        this.closest("span.highlighted").style.backgroundColor = "";
                    }
                }
            });
        }
        e.target.classList.remove("checked");
    }
}



function showAnnotation(e) {
    const myid = e.target.id;
    if (!e.target.classList.contains("checked")) {
        // if not checked
        for (var key in annoDict) {
            if (key == myid) {
                $('.' + key).each(function() {

                    var range = document.createRange();
                    range.selectNodeContents(this);

                    const firstNodeSpan = range.startContainer;
                    const lastNodeSpan = range.endContainer;

                    const span = document.createElement("span");
                    span.classList.add("highlighted");
                    span.style.backgroundColor = annoDict[key];

                    if (firstNodeSpan.closest("span.highlighted") && lastNodeSpan.closest("span.highlighted")) {
                        const highlightSpan = this.closest("span.highlighted");

                        highlightSpan.classList = [];
                        highlightSpan.classList.add("highlighted");
                        highlightSpan.classList.add("highlighted-" + key);
                        highlightSpan.style.backgroundColor = annoDict[key];
                    } else {
                        // if span doesn't exist
                        if (firstNodeSpan.nodeName === "SPAN" && lastNodeSpan.nodeName === "SPAN") {
                            const range = new Range();
                            range.setStartBefore(firstNodeSpan);
                            range.setEndAfter(lastNodeSpan);
                            // finally surround with span.user-highlighted.user-highlighted-{input}
                            span.classList.add("highlighted-" + key);
                            range.surroundContents(span);
                        }
                    }
                });
            }
        }
        e.target.classList.add("checked");
    } else {
        // if unchecked
        for (var key in annoDict) {
            if (key == myid) {
                $('.' + key).each(function() {
                    var range = document.createRange();
                    range.selectNodeContents(this);

                    const firstNodeSpan = range.startContainer;
                    const lastNodeSpan = range.endContainer;
                    if (firstNodeSpan.closest("span.highlighted") && lastNodeSpan.closest("span.highlighted")) {
                        if (this.closest("span.highlighted").classList.length === 2 &&
                            this.closest("span.highlighted").classList.contains("highlighted") &&
                            this.closest("span.highlighted").classList.contains("highlighted-" + myid)) {
                            this.closest("span.highlighted").classList.remove("highlighted-" + key);
                            this.closest("span.highlighted").style.backgroundColor = "";
                        }
                    }
                });
            }
        }
        e.target.classList.remove("checked");
    }
}


function showImportedAnnotations(myid, color) {
    $("#" + myid).css('background-color', color);
}


function exportAnnotations() {
    // export as csv
    var transcriptid = document.getElementById("transcriptid");
    var transcriptid_text = transcriptid.innerText
    let csvContent = "data:text/csv;charset=utf-8,";
    var elements = []
    for (var key in annoDict) {
        var annos = document.getElementsByClassName(key);
        for (let i = 0; i < annos.length; i++) {
            elements.push(annos[i])
        }
    }
    var uniqValues = new Set();
    uniqValues.add(["category", "speaker", "turnId", "tokenId", "token", "turnStart", "turnEnd"]);
    for (let i = 0; i < elements.length; i++) {
        var tdparent = elements[i].closest("td")
        var turnId = tdparent.getAttribute('id');
        var turnStart = tdparent.getAttribute('data-start');
        var turnEnd = tdparent.getAttribute('data-end');
        var speakerPseudo = tdparent.previousElementSibling.innerHTML;

        var annoClassList = elements[i].className.split(/\s+/);
        for (let annoindex = 0; annoindex < annoClassList.length; annoindex++) {
            if (annoClassList[annoindex] != "w") {
                var output = ['"' + annoClassList[annoindex] + '"', '"' + speakerPseudo + '"', '"' + turnId + '"', '"' + elements[i].id + '"', '"' + elements[i].textContent + '"', '"' + turnStart + '"', '"' + turnEnd + '"'].join(",");
                uniqValues.add(output);
            }
        }
    }
    uniqValues.forEach(key => csvContent += key + "\r\n");
    var encodedUri = encodeURI(csvContent);
    var link = document.createElement("a");
    link.setAttribute("href", encodedUri);
    link.setAttribute("download", transcriptid_text + "_annotations.csv");
    document.body.appendChild(link);
    link.click();
    // This will download the data file named "annotations.csv".
}


function getUserAnnotations(transcriptid, highlightedprefix) {
    var userAnnotations = [];
    var allElements = document.querySelectorAll('span');
    for (var i = 0; i < allElements.length; i++) {
        var classes = allElements[i].className.toString().split(/\s+/);
        for (var j = 0; j < classes.length; j++) {
            var cls = classes[j];
            // store all elements having the start "highlighted-" (custom elements) in a list
            if (cls.startsWith(highlightedprefix)) {
                var cls_anno = cls.substr(12);
                userAnnotations.push(allElements[i]);
            }
        }
    }
    return userAnnotations;
}

function exportUserAnnotationsJson() {
    var transcriptid = document.getElementById("transcriptid");
    var transcriptid_text = transcriptid.innerText
    var userAnnotations = getUserAnnotations("transcriptid", "highlighted-")

    var jsonArray = [];
    for (let i = 0; i < userAnnotations.length; i++) {
        var tdparent = userAnnotations[i].closest("td");
        var turnId = tdparent.getAttribute('id');
        var turnStart = tdparent.getAttribute('data-start');
        var turnEnd = tdparent.getAttribute('data-end');
        var speakerPseudo = tdparent.previousElementSibling.innerHTML;
        var annoClassList = userAnnotations[i].className.split(/\s+/);
        var spanids = userAnnotations[i].querySelectorAll('span')
        spanids_list = [];
        for (let ii = 0; ii < spanids.length; ii++) {
            spanids_list.push(spanids[ii].id);
        }
        var jsonObject = {};
        for (let annoindex = 0; annoindex < annoClassList.length; annoindex++) {
            if (annoClassList[annoindex] != "w" && annoClassList[annoindex] != "highlighted" && annoDict[annoClassList[annoindex]] == undefined) {
                cleanAnno = annoClassList[annoindex].replace('highlighted-', '');
                jsonObject.category = cleanAnno;
                jsonObject.speaker = speakerPseudo;
                jsonObject.turnId = turnId;
                jsonObject.tokenId = spanids_list.join(" ");
                jsonObject.token = userAnnotations[i].innerText;
                jsonObject.turnStart = turnStart;
                jsonObject.turnEnd = turnEnd;
                jsonObject.color = userAnnotations[i].style.backgroundColor;
            }
        }
        jsonArray.push(jsonObject);
    }
    var todayDate = new Date().toISOString().slice(0, 10);
    randomn = Math.floor(Math.random() * 1000000);
    const jsonfilename = transcriptid_text + "_" + String(todayDate) + "_" + String(randomn) + ".json";
    const jsonStr = JSON.stringify(jsonArray);
    var encodedUri = encodeURI(jsonStr);
    var link = document.createElement("a");
    link.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(jsonStr));
    link.setAttribute("download", jsonfilename);
    document.body.appendChild(link);
    link.click();
}



function exportUserAnnotationsCsv() {
    let csvContent = "data:text/csv;charset=utf-8,";
    var transcriptid = document.getElementById("transcriptid");
    var transcriptid_text = transcriptid.innerText
    var userAnnotations = getUserAnnotations("transcriptid", "highlighted-")
    var uniqValues = new Set();
    uniqValues.add(["category", "speaker", "turnId", "tokenId", "token", "turnStart", "turnEnd"]);
    for (let i = 0; i < userAnnotations.length; i++) {
        var tdparent = userAnnotations[i].closest("td");
        var turnId = tdparent.getAttribute('id');
        var turnStart = tdparent.getAttribute('data-start');
        var turnEnd = tdparent.getAttribute('data-end');
        var speakerPseudo = tdparent.previousElementSibling.innerHTML;
        var annoClassList = userAnnotations[i].className.split(/\s+/);
        var spanids = userAnnotations[i].querySelectorAll('span')
        spanids_list = [];
        for (let ii = 0; ii < spanids.length; ii++) {
            spanids_list.push(spanids[ii].id);
        }
        for (let annoindex = 0; annoindex < annoClassList.length; annoindex++) {
            if (annoClassList[annoindex] != "w" && annoClassList[annoindex] != "highlighted" && annoDict[annoClassList[annoindex]] == undefined) {
                cleanAnno = annoClassList[annoindex].replace('highlighted-', '');
                var output = ['"' + cleanAnno + '"', '"' + speakerPseudo + '"', '"' + turnId + '"', '"' + spanids_list.join(" ") + '"', '"' + userAnnotations[i].innerText + '"', '"' + turnStart + '"', '"' + turnEnd + '"'].join(",");
                uniqValues.add(output);
            }
        }
    }
    var todayDate = new Date().toISOString().slice(0, 10);
    randomn = Math.floor(Math.random() * 1000000);
    const csvfilename = transcriptid_text + "_" + String(todayDate) + "_" + String(randomn) + ".csv";
    uniqValues.forEach(key => csvContent += key + "\r\n");
    var encodedUri = encodeURI(csvContent);
    var link = document.createElement("a");
    link.setAttribute("href", encodedUri);
    link.setAttribute("download", csvfilename);
    document.body.appendChild(link);
    link.click();
}




function uploadDirectlyAnnotationsJson() {
    console.log(":we are in the function")
    var transcriptid = document.getElementById("transcriptid");
    var transcriptid_text = transcriptid.innerText
    var userAnnotations = getUserAnnotations("transcriptid", "highlighted-")

    var jsonArray =[];
    for (let i = 0; i < userAnnotations.length; i++) {
        var tdparent = userAnnotations[i].closest("td");
        var turnId = tdparent.getAttribute('id');
        var turnStart = tdparent.getAttribute('data-start');
        var turnEnd = tdparent.getAttribute('data-end');
        var speakerPseudo = tdparent.previousElementSibling.innerHTML;
        var annoClassList = userAnnotations[i].className.split(/\s+/);
        var spanids = userAnnotations[i].querySelectorAll('span')
        spanids_list =[];
        for (let ii = 0; ii < spanids.length; ii++) {
            spanids_list.push(spanids[ii].id);
        }
        var jsonObject = {
        };
        for (let annoindex = 0; annoindex < annoClassList.length; annoindex++) {
            if (annoClassList[annoindex] != "w" && annoClassList[annoindex] != "highlighted" && annoDict[annoClassList[annoindex]] == undefined) {
                cleanAnno = annoClassList[annoindex].replace('highlighted-', '');
                jsonObject.category = cleanAnno;
                jsonObject.speaker = speakerPseudo;
                jsonObject.turnId = turnId;
                jsonObject.tokenId = spanids_list.join(" ");
                jsonObject.token = userAnnotations[i].innerText;
                jsonObject.turnStart = turnStart;
                jsonObject.turnEnd = turnEnd;
                jsonObject.color = userAnnotations[i].style.backgroundColor;
            }
        }
        jsonArray.push(jsonObject);
    }
    var todayDate = new Date().toISOString().slice(0, 10);
    randomn = Math.floor(Math.random() * 1000000);
    const jsonfilename = transcriptid_text + "_" + String(todayDate) + "_" + String(randomn) + ".json";
    const jsonStr = JSON.stringify(jsonArray);
    console.log("we are creating dom elements")


        let directLink = document.createElement('form');

        directLink.style.display = "block";
        directLink.setAttribute('action', '/upload_direct');
        directLink.setAttribute('method', 'post');

    let inputField = document.createElement("input");
    inputField.setAttribute("type", "text");
    inputField.setAttribute("name", "data");
    inputField.value = jsonStr

    let fileNameField = document.createElement('input');
    fileNameField.setAttribute('type', 'text');
    fileNameField.setAttribute("name", "filename");
    fileNameField.value = jsonfilename;

    let inputSubmit = document.createElement('input');
    inputSubmit.setAttribute('type', 'submit');

    directLink.appendChild(inputField);
    directLink.appendChild(fileNameField);
    directLink.appendChild(inputSubmit);

    document.body.appendChild(directLink);


    inputSubmit.click();

}



function getSelectedText() {
    if (window.getSelection) {
        return window.getSelection();
    } else if (document.getSelection) {
        return document.getSelection();
    }
    // FireFox
    else if (document.selection) {
        return document.selection.createRange().text;
    }
}


function annotate(firstNodeSpan, lastNodeSpan, target, color, anno) {
    const span = document.createElement("span");

    span.classList.add("highlighted");
    span.style.backgroundColor = color;

    if (firstNodeSpan.closest("span.highlighted") && lastNodeSpan.closest("span.highlighted")) {
        if (target.closest("span.highlighted") != null) {
            if (target.closest("span.highlighted").classList.contains("highlighted-" + anno)) {
                target.closest("span.highlighted").replaceWith(...target.closest("span.highlighted").childNodes)
            } else {
                for (var j = 0; j < target.closest("span.highlighted").classList.length; j++) {
                    var cls = target.closest("span.highlighted").classList[j];
                    // store all elements having the start "highlighted-" (custom elements) in a list
                    if (cls.startsWith("highlighted-")) {
                        var cls_anno = cls.substr(12);
                        target.closest("span.highlighted").classList.remove("highlighted-" + cls_anno);
                        console.log("highlighted-" + cls_anno + " is deleted");
                    }
                }
                // delete prior annotation starting with "highlighted-" if its not predefined annotation
                target.closest("span.highlighted").classList.add("highlighted-" + anno);
                target.closest("span.highlighted").style.backgroundColor = color;
            }
        }
    } else {
        if (firstNodeSpan.nodeName === "SPAN" && lastNodeSpan.nodeName === "SPAN") {
            const range = new Range();
            range.setStartBefore(firstNodeSpan);
            range.setEndAfter(lastNodeSpan);
            // finally surround with span.highlighted.highlighted-{input}
            span.classList.add("highlighted-" + anno);
            range.surroundContents(span);
        }
    }
}

function escapeUserInput(usertag){
    // Tag can contain letters (A-Za-z), digits (0-9), hyphens ("-"), underscores ("_"), and be max 15 char. long
    var replacesusertag  = usertag.replace(/[^a-zA-Z0-9-_ ]/g, '').replace(" ", "_");
    var shortedusertag = replacesusertag.substring(0, 15)
    return shortedusertag;

}


function getUserInput() {
    var inputvalue = document.getElementById("userInput").value;
    return escapeUserInput(inputvalue);
    //return inputvalue.replace(" ", "_");
}

function getUserColor() {
    // return document.getElementById("annocolor").value;
    return document.getElementById("annocolor").value;
}